package com.eactive.eai.rms.onl.manage.sna.luhost;

import java.util.HashMap;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.servlet.ModelAndView;

import com.eactive.eai.rms.common.spring.BaseController;
import com.eactive.eai.rms.common.util.CamelCaseUtil;
import com.eactive.eai.rms.common.vo.JsonPageVo;
import com.google.gson.Gson;

@Controller
public class LuHostController extends BaseController{
	
	@Autowired
	@Qualifier("luHostService")
	private LuHostService service; 
	
	@RequestMapping(value= "/onl/admin/sna/luhostMan.view")
	private String viewList(HttpServletRequest request, @RequestParam(value = "cmd", required = false ) String cmd ) throws Exception {
		if (cmd == null || "LIST".equals(cmd.toUpperCase())){
			cmd = "";
		}else {
			cmd = CamelCaseUtil.converCamelCase(cmd);
		}
		String path = request.getServletPath();
		return path.split("[.]")[0]+cmd;
	}   
	
	@RequestMapping(value= "/onl/admin/sna/luhostMan.json", params = "cmd=LIST")
	private ModelAndView selectList(HttpServletRequest request,
			JsonPageVo pageVo ,@RequestParam HashMap<String,Object> paramMap
			) throws Exception {
			
		HashMap map = service.selectList( pageVo.getStartNum(), pageVo.getEndNum());
		pageVo.setTotalCount((Integer)map.get("totalCount"));
		
		Map resultMap = new HashMap();
		resultMap.put("total"  , pageVo.getTotal());  //전체 페이지수
		resultMap.put("page"   , pageVo.getPage());   //현재 페이지수
		resultMap.put("records", pageVo.getTotalCount());//전체 레코드건수	
		resultMap.put("rows"   , map.get("list"));
		
		ModelAndView modelAndView = new ModelAndView("jsonView",resultMap);		
		return modelAndView;
	}	
	
	@RequestMapping(value= "/onl/admin/sna/luhostMan.json",params = "cmd=DETAIL")
	private ModelAndView selectDetail(HttpServletRequest request,HttpServletResponse response,String snaAdptrSevrName) throws Exception {
		HashMap map = service.selectDetail(snaAdptrSevrName);
		ModelAndView modelAndView = new ModelAndView("jsonView",map);	
		
		return modelAndView;
	}
	
	@RequestMapping(value= "/onl/admin/sna/luhostMan.json",params = "cmd=INSERT")
	private ModelAndView insert(HttpServletRequest request,
			HttpServletResponse response, @RequestParam HashMap<String,Object> map  ) throws Exception {
		
		String message = "success";
		int luGroupCnt = 0;
		
		luGroupCnt = service.selectHostCnt(map);
		
		if(luGroupCnt == 0){
			service.insert(map);
		}else{
			message = "이미 존재하는 HOST입니다";
		}
		
		Map resultMap = new HashMap();
		resultMap.put("message"   , message);
		ModelAndView modelAndView = new ModelAndView("jsonView",resultMap);		
		return modelAndView;
		
	}	
	
	@RequestMapping(value= "/onl/admin/sna/luhostMan.json",params = "cmd=UPDATE")
	private ModelAndView update(HttpServletRequest request,HttpServletResponse response, @RequestParam HashMap<String,Object> map) throws Exception {
		String message = "success";
		
		service.update(map);
		
		Map resultMap = new HashMap();
		resultMap.put("message"   , message);
		ModelAndView modelAndView = new ModelAndView("jsonView",resultMap);		
		return modelAndView;
		
	}
	
	@RequestMapping(value= "/onl/admin/sna/luhostMan.json",params = "cmd=DELETE_LIST")
	private ModelAndView deleteMulti(HttpServletRequest request,
			HttpServletResponse response, @RequestParam HashMap<String,Object> map ) throws Exception {
		HashMap paramMap = new HashMap();
		
		String[] snaAdptrSevrNameArr = ((String) map.get("snaAdptrSevrName")).split(",");
		
		int idx = 0;
		for(String snaAdptrSevrName : snaAdptrSevrNameArr){
			paramMap.put("snaAdptrSevrName", snaAdptrSevrName);
			
			service.delete(paramMap);
			//service.deleteInfo(paramMap);
			idx++;
		}
		
		String message = "총"+idx+"건을 삭제하였습니다";
		Map resultMap = new HashMap();
		resultMap.put("message"   , message);
		ModelAndView modelAndView = new ModelAndView("jsonView",resultMap);		
		return modelAndView;
		
	}	
	
	@RequestMapping(value= "/onl/admin/sna/luhostMan.json",params = "cmd=DELETE")
	private ModelAndView delete(HttpServletRequest request,
			HttpServletResponse response,@RequestParam HashMap<String,Object> map) throws Exception {
		String message = "success";
		service.delete(map);
		Map resultMap = new HashMap();
		resultMap.put("message"   , message);
		ModelAndView modelAndView = new ModelAndView("jsonView",resultMap);		
		return modelAndView;
		
	}	
	
	@RequestMapping(value= "/onl/admin/sna/luhostMan.excel",params = "cmd=LIST_GRID_TO_EXCEL")
	public ModelAndView listGridToExcel(HttpServletRequest request, HttpServletResponse response, @RequestParam HashMap<String,Object> paramMap) throws Exception {
		HashMap<String,Object> resultMap = new HashMap<String,Object>();
		
		String headersStr = (String) paramMap.get("headersStr"); 
		headersStr = headersStr.substring(0, headersStr.length()-1);
		paramMap.put("headersStr", headersStr);
		
    	Gson gson = new Gson();
    	@SuppressWarnings("unchecked")
    	HashMap<String, Object> list = service.selectListToExcel(paramMap);
    	
    	String jsonStr = gson.toJson(list.get("list"));
    	HashMap<String, Object>[] list2 = gson.fromJson(jsonStr, HashMap[].class);
    	
		String[] headers = gson.fromJson((String) paramMap.get("header"), String[].class);
		String[] headerTitles = gson.fromJson((String)paramMap.get("headerTitle"), String[].class);
		
		HashMap<String, Object>[] lmerge = null; 
		String merge = (String)paramMap.get("merge");
		if (merge !=null){
			lmerge = gson.fromJson(merge, HashMap[].class);
		}
    	
    	resultMap.put("headers", headers);
    	resultMap.put("headerTitles", headerTitles);
    	resultMap.put("datas", list2);
    	resultMap.put("fileName", (String)paramMap.get("fileName"));
    	resultMap.put("merge", lmerge);
		ModelAndView modelAndView = new ModelAndView("excelView",resultMap);	
        return modelAndView;
    }	

}
